;; theme file

(define theme-name 'Dark-Tab)

;;need hash tables for icon cache 
;;
(require 'rep.data.tables)

(defgroup Dark-Tab:group "Dark Tab"
  :group appearance)

(defgroup Dark-Tab:colors-group "colors"
  :group (appearance Dark-Tab:group))

(defgroup Dark-Tab:borders-group "borders"
  :group (appearance Dark-Tab:group))

(defgroup Dark-Tab:buttons-group "buttons"
  :group (appearance Dark-Tab:group))

(defgroup Dark-Tab:left-buttons-group "Left Titlebar Buttons"
  :group (appearance Dark-Tab:group Dark-Tab:buttons-group))

(defgroup Dark-Tab:right-buttons-group "Right Titlebar Buttons"
  :group (appearance Dark-Tab:group Dark-Tab:buttons-group))

(defcustom dark-tab:focused-color "#FEFEFE"
  "Focused title text color."
  :group (appearance Dark-Tab:group Dark-Tab:colors-group)
  :type color)

(defcustom dark-tab:highlighted-color "#E5E5E5"
  "Highlighted title text color."
  :group (appearance Dark-Tab:group Dark-Tab:colors-group)
  :type color)

(defcustom dark-tab:clicked-color "#CBCBCB"
  "Clicked title text color."
  :group (appearance Dark-Tab:group Dark-Tab:colors-group)
  :type color)

(defcustom dark-tab:inactive-color "#B2B2B2"
  "Inactive title text color."
  :group (appearance Dark-Tab:group Dark-Tab:colors-group)
  :type color)

(defcustom dark-tab:inactive-highlighted-color "#989898"
  "Inactive Highlighted title text color."
  :group (appearance Dark-Tab:group Dark-Tab:colors-group)
  :type color)

(defcustom dark-tab:inactive-clicked "#808080"
  "Inactive Clicked title text color."
  :group (appearance Dark-Tab:group Dark-Tab:colors-group)
  :type color)

(defcustom dark-tab:borders-dimension 4 "Width of window border."
  :group (appearance Dark-Tab:group Dark-Tab:borders-group)
  :type number
  :range (0 . 10))

(defcustom dark-tab:left-buttons `((menu ,t) (shade ,t) (sticky ,nil))
  "Left Titlebar Buttons (from left to right)"
  :group (appearance Dark-Tab:group Dark-Tab:buttons-group Dark-Tab:left-buttons-group)
  :type (v-and (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))))

(defcustom dark-tab:right-buttons `((close ,t) (maximize ,nil) (minimize ,nil))
  "Right Titlebar Buttons (from right to left)"
  :group (appearance Dark-Tab:group Dark-Tab:buttons-group Dark-Tab:right-buttons-group)
  :type (v-and (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))
               (v-and (choice \(none\) close menu maximize minimize shade sticky space send-to-prev send-to-next lock raise-lower move-resize rename frame-typ)
                      (boolean "Show in transients"))))

(defvar dark-tab:show-window-icons t)

(def-frame-class tab-l ()
  (bind-keys
    tab-l-keymap "Button1-Off"
   '(call-command
     (lambda ()
       (unshade-window (current-event-window))
       (setq pos-x (car (window-position (current-event-window))))
       (setq pos-y (cdr (window-position (current-event-window))))
       (setq dim (window-dimensions (current-event-window)))
       (setq fdim (window-frame-dimensions (current-event-window)))
       (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ (car dim) (cdr dim) 18)) 3))
       (if (eq (window-get (current-event-window)
                           'current-frame-style) 'Dark-Tab-Right)
           (setq framehigh 0)
         (if (or (eq (window-get (current-event-window)
                                 'type) 'default)
                 (eq (window-get (current-event-window)
                                 'type) 'transient))
             (setq framehigh (+ 16 framew))
           (setq framehigh (+ 18 framew))))
       (setq dim-x (- (car (window-dimensions (current-event-window)))
                      framehigh))
       (setq dim-y (+ (cdr (window-dimensions (current-event-window)))
                      framehigh))
       (if (<= pos-x 0) (setq pos-x 0))
       (set-frame-style (current-event-window) 'Dark-Tab-Left)
       (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y))))
  (bind-keys
    tab-l-keymap "Button2-Off"
   '(call-command
     (lambda ()
       (unshade-window (current-event-window))
       (setq pos-x (car (window-position (current-event-window))))
       (setq pos-y (cdr (window-position (current-event-window))))
       (setq dim-x (car (window-dimensions (current-event-window))))
       (setq dim-y (cdr (window-dimensions (current-event-window))))
       (setq fdim (window-frame-dimensions (current-event-window)))
       (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ dim-x dim-y 18)) 3))
       (if (>= (+ pos-y dim-y 18 framew) (screen-height))
           (setq pos-y (- (screen-height) dim-y 18 framew)))
       (if (<= pos-y 0) (setq pos-y 0))
       (if (eq (window-get (current-event-window)
                           'current-frame-style) 'Dark-Tab)
           (set-frame-style (current-event-window) 'Dark-Tab-Bottom)
         (set-frame-style (current-event-window) 'Dark-Tab))
       (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y))))
  (bind-keys
    tab-l-keymap "Button3-Off"
   '(call-command
     (lambda ()
       (unshade-window (current-event-window))
       (setq pos-x (car (window-position (current-event-window))))
       (setq pos-y (cdr (window-position (current-event-window))))
       (setq dim (window-dimensions (current-event-window)))
       (setq fdim (window-frame-dimensions (current-event-window)))
       (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ (car dim) (cdr dim) 18)) 3))
       (if (eq (window-get (current-event-window)
                           'current-frame-style) 'Dark-Tab-Left)
           (setq framehigh 0)
         (if (or (eq (window-get (current-event-window)
                                 'type) 'default)
                 (eq (window-get (current-event-window)
                                 'type) 'transient))
             (setq framehigh (+ 16 framew))
           (setq framehigh (+ 18 framew))))
       (setq dim-x (- (car (window-dimensions (current-event-window)))
                      framehigh))
       (setq dim-y (+ (cdr (window-dimensions (current-event-window)))
                      framehigh))
       (if (>= (+ pos-x dim-x framehigh framew framew) (screen-width))
           (setq pos-x (- (screen-width) dim-x 18 framew)))
       (set-frame-style (current-event-window) 'Dark-Tab-Right)
       (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y)))))

(def-frame-class tab-rs ()
  (bind-keys
    tab-rs-keymap "Button1-Off"
   '(call-command
     (lambda ()
       (when (not (eq (window-get (current-event-window)
                                  'current-frame-style) 'Dark-Tab-Left))
         (unshade-window (current-event-window))
         (setq pos-x (car (window-position (current-event-window))))
         (setq pos-y (cdr (window-position (current-event-window))))
         (setq dim (window-dimensions (current-event-window)))
         (setq fdim (window-frame-dimensions (current-event-window)))
         (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ (car dim) (cdr dim) 18)) 3))
         (if (eq (window-get (current-event-window)
                           'current-frame-style) 'Dark-Tab-Right)
             (setq framehigh 0)
           (setq framehigh (+ 16 framew)))
         (setq dim-x (- (car (window-dimensions (current-event-window)))
                        framehigh))
         (setq dim-y (+ (cdr (window-dimensions (current-event-window)))
                        framehigh))
         (if (<= pos-x 0) (setq pos-x 0))
         (set-frame-style (current-event-window) 'Dark-Tab-Left)
         (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y)))))
  (bind-keys
    tab-rs-keymap "Button2-Off"
   '(call-command
     (lambda ()
       (unshade-window (current-event-window))
       (setq pos-x (car (window-position (current-event-window))))
       (setq pos-y (cdr (window-position (current-event-window))))
       (setq dim-x (car (window-dimensions (current-event-window))))
       (setq dim-y (cdr (window-dimensions (current-event-window))))
       (setq fdim (window-frame-dimensions (current-event-window)))
       (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ dim-x dim-y 18)) 3))

       (if (or (eq (window-get (current-event-window)
                               'type) 'default)
               (eq (window-get (current-event-window)
                               'type) 'transient))
           (setq framehigh 16)
         (setq framehigh 18))
       (setq dim-x (+ dim-x framehigh framew))
       (setq dim-y (- dim-y framehigh framew))
       (if (>= (+ pos-y dim-y 18 framew) (screen-height))
           (setq pos-y (- (screen-height) dim-y 18 framew)))
       (if (<= pos-y 0) (setq pos-y 0))
       (set-frame-style (current-event-window) 'Dark-Tab)
       (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y))))
  (bind-keys
    tab-rs-keymap "Button3-Off"
   '(call-command
     (lambda ()

       (when (not (eq (window-get (current-event-window)
                                  'current-frame-style) 'Dark-Tab-Right))
         (unshade-window (current-event-window))
         (setq pos-x (car (window-position (current-event-window))))
         (setq pos-y (cdr (window-position (current-event-window))))
         (setq dim (window-dimensions (current-event-window)))
         (setq fdim (window-frame-dimensions (current-event-window)))
         (setq framew (/ (- (+ (car fdim) (cdr fdim)) (+ (car dim) (cdr dim) 18)) 3))
         (if (eq (window-get (current-event-window)
                             'current-frame-style) 'Dark-Tab-Left)
             (setq framehigh 0)
           (setq framehigh (+ 16 framew)))
         (setq dim-x (- (car (window-dimensions (current-event-window)))
                        framehigh))
         (setq dim-y (+ (cdr (window-dimensions (current-event-window)))
                        framehigh))
         (if (>= (+ pos-x dim-x) (screen-width))
             (setq pos-x (- (screen-width) dim-x 18 framew)))
         (set-frame-style (current-event-window) 'Dark-Tab-Right)
         (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y))))))

(defvar prev-button-keymap
  (bind-keys (make-keymap)
			 "Button3-Off" 'send-group-to-next-workspace
             "Button2-Click" 'popup-workspace-list
             "Button1-Off" 'send-group-to-previous-workspace))

(defvar next-button-keymap
  (bind-keys (make-keymap)
             "Button3-Off" 'send-group-to-previous-workspace
             "Button2-Click" 'popup-workspace-list
             "Button1-Off" 'send-group-to-next-workspace))

(def-frame-class frame-typ-button ()
  (bind-keys
    frame-typ-button-keymap "Button1-Off"
   '(call-command
     (lambda ()
       (setq pos-x (car (window-position (current-event-window))))
       (setq pos-y (cdr (window-position (current-event-window))))
       (setq dim-x (car (window-dimensions (current-event-window))))
       (setq dim-y (cdr (window-dimensions (current-event-window))))
       (setq type (window-get (current-event-window) 'type))
       (setq style (window-get (current-event-window) 'current-frame-style))

       (if (eq type 'default)
           (setq typ 'transient)
         (setq typ 'default))

       (when (or (eq type 'shaped)
                 (eq type 'utility))
         (setq typ 'default)
         (setq dim-x (- dim-x (* dark-tab:borders-dimension 2)))         
         (setq dim-y (- dim-y dark-tab:borders-dimension))
         (when
             (not (or (eq style 'Dark-Tab)
                      (eq style 'Dark-Tab-Bottom)))
           (setq dim-x (+ dim-x dark-tab:borders-dimension))
           (setq dim-y (- dim-y dark-tab:borders-dimension))))

       (when (eq type 'shaped-transient)
         (setq typ 'transient)
         (setq dim-x (- dim-x (* dark-tab:borders-dimension 2)))
         (setq dim-y (- dim-y dark-tab:borders-dimension))
         (when
             (not (or (eq style 'Dark-Tab)
                      (eq style 'Dark-Tab-Bottom)))
           (setq dim-x (+ dim-x dark-tab:borders-dimension))
           (setq dim-y (- dim-y dark-tab:borders-dimension))))

       (set-window-type (current-event-window) typ)
       (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y))))

  (bind-keys
   frame-typ-button-keymap "Button2-Off"
   '(call-command
     (lambda ()
       (setq pos-x (car (window-position (current-event-window))))
       (setq pos-y (cdr (window-position (current-event-window))))
       (setq dim-x (car (window-dimensions (current-event-window))))
       (setq dim-y (cdr (window-dimensions (current-event-window))))
       (setq type (window-get (current-event-window) 'type))
       (setq style (window-get (current-event-window) 'current-frame-style))

       (when (or (eq type 'default)
                 (eq type 'transient))
         (setq typ 'shaped)
         (when (or (eq style 'Dark-Tab)
                   (eq style 'Dark-Tab-Bottom))
           (setq dim-x (+ dim-x (* dark-tab:borders-dimension 2)))
           (setq dim-y (+ dim-y dark-tab:borders-dimension 18)))
         (when (not (eq style 'Dark-Tab)
                    (eq style 'Dark-Tab-Bottom))
           (setq dim-y (+ dim-y (* dark-tab:borders-dimension 2)))
           (setq dim-x (+ dim-x dark-tab:borders-dimension 18))))

       (when (or (eq type 'shaped)
                 (eq type 'shaped-transient)
                 (eq type 'utility))
         (setq typ 'shaped)
         (if (or (eq style 'Dark-Tab)
                 (eq style 'Dark-Tab-Bottom))
             (setq dim-y (+ dim-y 18))
           (setq dim-x (+ dim-x 18))))

       (set-window-type (current-event-window) 'unframed)
       (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y))))
 
(bind-keys
  frame-typ-button-keymap "Button3-Off"
  '(call-command
    (lambda ()
       (setq pos-x (car (window-position (current-event-window))))
       (setq pos-y (cdr (window-position (current-event-window))))
       (setq dim-x (car (window-dimensions (current-event-window))))
       (setq dim-y (cdr (window-dimensions (current-event-window))))
       (setq type (window-get (current-event-window) 'type))
       (setq style (window-get (current-event-window) 'current-frame-style))

       (if (or (eq type 'shaped)
               (eq type 'utility))
           (setq typ 'shaped-transient)
         (setq typ 'shaped))

       (when (eq type 'default)
         (setq typ 'shaped)
         (setq dim-x (+ dim-x (* dark-tab:borders-dimension 2)))
         (setq dim-y (+ dim-y dark-tab:borders-dimension))
         (when
             (not (or (eq style 'Dark-Tab)
                      (eq style 'Dark-Tab-Bottom)))
           (setq dim-x (- dim-x dark-tab:borders-dimension))
           (setq dim-y (+ dim-y dark-tab:borders-dimension))))

       (when (eq type 'transient)
         (setq typ 'shaped-transient)
         (setq dim-x (+ dim-x (* dark-tab:borders-dimension 2)))
         (setq dim-y (+ dim-y dark-tab:borders-dimension))
         (when
             (not (or (eq style 'Dark-Tab)
                      (eq style 'Dark-Tab-Bottom)))
           (setq dim-x (- dim-x dark-tab:borders-dimension))
           (setq dim-y (+ dim-y dark-tab:borders-dimension))))

       (set-window-type (current-event-window) typ)
       (move-resize-window-to (current-event-window) pos-x pos-y dim-x dim-y)))))

(define top-border-images 
  `((focused . ,(make-image "top-border-f.png"))
	(inactive . ,(make-image "top-border-i.png"))))

(define top-left-corner-images 
  `((focused . ,(make-image "top-left-corner-f.png"))
	(inactive . ,(make-image "top-left-corner-i.png"))))

(define top-left-corner-shaped-images 
  `((focused . ,(make-image "top-left-corner-shaped-f.png"))
	(inactive . ,(make-image "top-left-corner-shaped-i.png"))))

(define tab-left-images 
  `((focused . ,(make-image "tab-left-f.png"))
	(inactive . ,(make-image "tab-left-i.png"))))

(define tab-left-icon-images 
  `((focused . ,(make-image "tab-left-icon-f.png"))
	(inactive . ,(make-image "tab-left-icon-i.png"))))

(define tab-images 
  `((focused . ,(make-image "tab-f.png"))
	(inactive . ,(make-image "tab-i.png"))))

(define tab-right-images 
  `((focused . ,(make-image "tab-right-f.png"))
	(inactive . ,(make-image "tab-right-i.png"))))

(define title-images 
  `((focused . ,(make-image "title-f.png"))
	(inactive . ,(make-image "title-i.png"))))

(define icon-title-images 
  `((focused . ,(make-image "icon-title-images-f.png"))
	(inactive . ,(make-image "icon-title-images-i.png"))))

(define title-colors-images
  (lambda ()
    `((focused . ,dark-tab:focused-color)
      (highlighted . ,dark-tab:highlighted-color)
      (clicked . ,dark-tab:clicked-color)
      (inactive . ,dark-tab:inactive-color)
      (inactive-highlighted . ,dark-tab:inactive-highlighted-color)
      (inactive-clicked . ,dark-tab:inactive-clicked))))

(define top-right-corner-images 
  `((focused . ,(make-image "top-right-corner-f.png"))
	(inactive . ,(make-image "top-right-corner-i.png"))))

(define top-right-corner-shaped-images 
  `((focused . ,(make-image "top-right-corner-shaped-f.png"))
	(inactive . ,(make-image "top-right-corner-shaped-i.png"))))

(define menu-button-images 
  `((focused . ,(make-image "menu-button-f.png"))
	(highlighted . ,(make-image "menu-button-h.png"))
	(clicked . ,(make-image "menu-button-c.png"))
	(inactive . ,(make-image "menu-button-i.png"))
	(inactive-highlighted . ,(make-image "menu-button-ih.png"))
	(inactive-clicked . ,(make-image "menu-button-ic.png"))))

(define shade-button-images 
  `((focused . ,(make-image "shade-button-f.png"))
	(highlighted . ,(make-image "shade-button-h.png"))
	(clicked . ,(make-image "shade-button-c.png"))
	(inactive . ,(make-image "shade-button-i.png"))
	(inactive-highlighted . ,(make-image "shade-button-ih.png"))
	(inactive-clicked . ,(make-image "shade-button-ic.png"))))

(define unshade-button-images 
  `((focused . ,(make-image "unshade-button-f.png"))
	(highlighted . ,(make-image "unshade-button-h.png"))
	(clicked . ,(make-image "unshade-button-c.png"))
	(inactive . ,(make-image "unshade-button-i.png"))
	(inactive-highlighted . ,(make-image "unshade-button-ih.png"))
	(inactive-clicked . ,(make-image "unshade-button-ic.png"))))

(define sticky-button-images 
  `((focused . ,(make-image "sticky-button-f.png"))
	(highlighted . ,(make-image "sticky-button-h.png"))
	(clicked . ,(make-image "sticky-button-c.png"))
	(inactive . ,(make-image "sticky-button-i.png"))
	(inactive-highlighted . ,(make-image "sticky-button-ih.png"))
	(inactive-clicked . ,(make-image "sticky-button-ic.png"))))

(define unsticky-button-images 
  `((focused . ,(make-image "unsticky-button-f.png"))
	(highlighted . ,(make-image "unsticky-button-h.png"))
	(clicked . ,(make-image "unsticky-button-c.png"))
	(inactive . ,(make-image "unsticky-button-i.png"))
	(inactive-highlighted . ,(make-image "unsticky-button-ih.png"))
	(inactive-clicked . ,(make-image "unsticky-button-ic.png"))))

(define iconify-button-images 
  `((focused . ,(make-image "iconify-button-f.png"))
	(highlighted . ,(make-image "iconify-button-h.png"))
	(clicked . ,(make-image "iconify-button-c.png"))
	(inactive . ,(make-image "iconify-button-i.png"))
	(inactive-highlighted . ,(make-image "iconify-button-ih.png"))
	(inactive-clicked . ,(make-image "iconify-button-ic.png"))))

(define maximize-button-images 
  `((focused . ,(make-image "maximize-button-f.png"))
	(highlighted . ,(make-image "maximize-button-h.png"))
	(clicked . ,(make-image "maximize-button-c.png"))
	(inactive . ,(make-image "maximize-button-i.png"))
	(inactive-highlighted . ,(make-image "maximize-button-ih.png"))
	(inactive-clicked . ,(make-image "maximize-button-ic.png"))))

(define unmaximize-button-images 
  `((focused . ,(make-image "unmaximize-button-f.png"))
	(highlighted . ,(make-image "unmaximize-button-h.png"))
	(clicked . ,(make-image "unmaximize-button-c.png"))
	(inactive . ,(make-image "unmaximize-button-i.png"))
	(inactive-highlighted . ,(make-image "unmaximize-button-ih.png"))
	(inactive-clicked . ,(make-image "unmaximize-button-ic.png"))))

(define close-button-images 
  `((focused . ,(make-image "close-button-f.png"))
	(highlighted . ,(make-image "close-button-h.png"))
	(clicked . ,(make-image "close-button-c.png"))
	(inactive . ,(make-image "close-button-i.png"))
	(inactive-highlighted . ,(make-image "close-button-ih.png"))
	(inactive-clicked . ,(make-image "close-button-ic.png"))))

(define lock-button-images 
  `((focused . ,(make-image "lock-button-f.png"))
	(highlighted . ,(make-image "lock-button-h.png"))
	(clicked . ,(make-image "lock-button-c.png"))
	(inactive . ,(make-image "lock-button-i.png"))
	(inactive-highlighted . ,(make-image "lock-button-ih.png"))
	(inactive-clicked . ,(make-image "lock-button-ic.png"))))

(define unlock-button-images 
  `((focused . ,(make-image "unlock-button-f.png"))
	(highlighted . ,(make-image "unlock-button-h.png"))
	(clicked . ,(make-image "unlock-button-c.png"))
	(inactive . ,(make-image "unlock-button-i.png"))
	(inactive-highlighted . ,(make-image "unlock-button-ih.png"))
	(inactive-clicked . ,(make-image "unlock-button-ic.png"))))

(define prev-button-images 
  `((focused . ,(make-image "prev-button-f.png"))
	(highlighted . ,(make-image "prev-button-h.png"))
	(clicked . ,(make-image "prev-button-c.png"))
	(inactive . ,(make-image "prev-button-i.png"))
	(inactive-highlighted . ,(make-image "prev-button-ih.png"))
	(inactive-clicked . ,(make-image "prev-button-ic.png"))))

(define prev-last-button-images 
  `((focused . ,(make-image "prev-last-button-f.png"))
	(highlighted . ,(make-image "prev-last-button-h.png"))
	(clicked . ,(make-image "prev-last-button-c.png"))
	(inactive . ,(make-image "prev-last-button-i.png"))
	(inactive-highlighted . ,(make-image "prev-last-button-ih.png"))
	(inactive-clicked . ,(make-image "prev-last-button-ic.png"))))

(define next-button-images 
  `((focused . ,(make-image "next-button-f.png"))
	(highlighted . ,(make-image "next-button-h.png"))
	(clicked . ,(make-image "next-button-c.png"))
	(inactive . ,(make-image "next-button-i.png"))
	(inactive-highlighted . ,(make-image "next-button-ih.png"))
	(inactive-clicked . ,(make-image "next-button-ic.png"))))

(define next-last-button-images 
  `((focused . ,(make-image "next-last-button-f.png"))
	(highlighted . ,(make-image "next-last-button-h.png"))
	(clicked . ,(make-image "next-last-button-c.png"))
	(inactive . ,(make-image "next-last-button-i.png"))
	(inactive-highlighted . ,(make-image "next-last-button-ih.png"))
	(inactive-clicked . ,(make-image "next-last-button-ic.png"))))

(define raise-lower-button-images 
  `((focused . ,(make-image "raise-lower-button-f.png"))
	(highlighted . ,(make-image "raise-lower-button-h.png"))
	(clicked . ,(make-image "raise-lower-button-c.png"))
	(inactive . ,(make-image "raise-lower-button-i.png"))
	(inactive-highlighted . ,(make-image "raise-lower-button-ih.png"))
	(inactive-clicked . ,(make-image "raise-lower-button-ic.png"))))

(define ontop-button-images 
  `((focused . ,(make-image "ontop-button-f.png"))
	(highlighted . ,(make-image "ontop-button-h.png"))
	(clicked . ,(make-image "ontop-button-c.png"))
	(inactive . ,(make-image "ontop-button-i.png"))
	(inactive-highlighted . ,(make-image "ontop-button-ih.png"))
	(inactive-clicked . ,(make-image "ontop-button-ic.png"))))

(define unontop-button-images 
  `((focused . ,(make-image "unontop-button-f.png"))
	(highlighted . ,(make-image "unontop-button-h.png"))
	(clicked . ,(make-image "unontop-button-c.png"))
	(inactive . ,(make-image "unontop-button-i.png"))
	(inactive-highlighted . ,(make-image "unontop-button-ih.png"))
	(inactive-clicked . ,(make-image "unontop-button-ic.png"))))

(define move-resize-button-images 
  `((focused . ,(make-image "move-resize-button-f.png"))
	(highlighted . ,(make-image "move-resize-button-h.png"))
	(clicked . ,(make-image "move-resize-button-c.png"))
	(inactive . ,(make-image "move-resize-button-i.png"))
	(inactive-highlighted . ,(make-image "move-resize-button-ih.png"))
	(inactive-clicked . ,(make-image "move-resize-button-ic.png"))))

(define rename-button-images 
  `((focused . ,(make-image "rename-button-f.png"))
	(highlighted . ,(make-image "rename-button-h.png"))
	(clicked . ,(make-image "rename-button-c.png"))
	(inactive . ,(make-image "rename-button-i.png"))
	(inactive-highlighted . ,(make-image "rename-button-ih.png"))
	(inactive-clicked . ,(make-image "rename-button-ic.png"))))

(define frame-typ-button-images 
  `((focused . ,(make-image "frame-typ-button-f.png"))
	(highlighted . ,(make-image "frame-typ-button-h.png"))
	(clicked . ,(make-image "frame-typ-button-c.png"))
	(inactive . ,(make-image "frame-typ-button-i.png"))
	(inactive-highlighted . ,(make-image "frame-typ-button-ih.png"))
	(inactive-clicked . ,(make-image "frame-typ-button-ic.png"))))

(define left-border-images 
  `((focused . ,(make-image "left-border-f.png"))
	(inactive . ,(make-image "left-border-i.png"))))

(define bottom-left-corner-images 
  `((focused . ,(make-image "bottom-left-corner-f.png"))
	(inactive . ,(make-image "bottom-left-corner-i.png"))))

(define bottom-border-images 
  `((focused . ,(make-image "bottom-border-f.png"))
	(inactive . ,(make-image "bottom-border-i.png"))))

(define right-border-images 
  `((focused . ,(make-image "right-border-f.png"))
	(inactive . ,(make-image "right-border-i.png"))))

(define bottom-right-corner-images 
  `((focused . ,(make-image "bottom-right-corner-f.png"))
	(inactive . ,(make-image "bottom-right-corner-i.png"))))

(define sticky-image-set
  (lambda (w)
    (if (window-get w 'sticky)
        unsticky-button-images
      sticky-button-images)))

(define shade-image-set
  (lambda (w)
    (if (window-get w 'shaded)
        unshade-button-images
      shade-button-images)))

(define maximize-image-set
  (lambda (w)
    (if (window-get w 'unmaximized-geometry)
        unmaximize-button-images
      maximize-button-images)))

(defmacro window-in-workspace-p (w space)
  `(memq ,space (window-get ,w 'workspaces)))

(define (get-first-workspace) 1)

(define prev-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-first-workspace) 1))
            (window-get w 'sticky))
        prev-last-button-images
      prev-button-images)))

(define (get-last-workspace)
  (aref
   (nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS)) 0))

(define next-image-set
  (lambda (w)
    (if (or (window-in-workspace-p w (- (get-last-workspace) 1))
            (window-get w 'sticky))
        next-last-button-images
      next-button-images)))

(define lock-image-set
  (lambda (w)
    (if (window-get w 'fixed-position)
        unlock-button-images
      lock-button-images)))

(define raise-lower-image-set
  (lambda (w)
    (if (= (window-get w 'depth) 0)
        raise-lower-button-images
      (if (> (window-get w 'depth) 0)
          ontop-button-images
        unontop-button-images))))

;; window icons
;; ripped from Crux
;;
(define icon-table (make-weak-table eq-hash eq))

(define (window-icon w)
  (if dark-tab:show-window-icons
      (or (table-ref icon-table w)
          (let ((icon (window-icon-image w)))
            (if icon
                (let ((scaled (scale-image icon 12 12)))
                  (table-set icon-table w scaled)
                  scaled)
              icon-title-images)))
    tab-images))

(define frame-width
  (lambda (w)
    (if (or (eq (window-type w) 'default)
			(eq (window-type w) 'transient))
        dark-tab:borders-dimension
      2)))

(define frame-edge
  (lambda (w)
    (if (or (eq (window-type w) 'default)
            (eq (window-type w) 'transient))
        (- dark-tab:borders-dimension)
      -2)))


(define-frame-class 'prev-button '((keymap . prev-button-keymap)))
(define-frame-class 'next-button '((keymap . next-button-keymap)))
(define-frame-class 'frame-typ-button '((keymap . frame-typ-button-keymap)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                   

(define default-border-corner-group 
  `(((class . top-left-corner)
     (background . ,top-left-corner-images)
     (left-edge . ,frame-edge)
     (top-edge . -18)
     (height . 18)
     (width . ,frame-width))
	((class . top-right-corner)
     (background . ,top-right-corner-images)
     (top-edge . -18)
     (right-edge . ,frame-edge)
     (height . 18)
     (width . ,frame-width))
    ((class . title)
     (background . ,title-images)
     (right-edge . 0)
     (top-edge . -16)
     (height . 16)
     (width . 2))))

(define border-group
  `(((class . left-border)
     (background . ,left-border-images)
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (top-edge . 0)
     (width . ,frame-width)
     (bottom-edge . 0))
	((class . bottom-left-corner)
     (background . ,bottom-left-corner-images)
     (left-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-border)
     (background . ,bottom-border-images)
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (right-edge . 0)
     (height . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . bottom-right-corner)
     (background . ,bottom-right-corner-images)
     (right-edge . ,frame-edge)
     (height . ,frame-width)
     (width . ,frame-width)
     (bottom-edge . ,frame-edge))
	((class . right-border)
     (background . ,right-border-images)
     (cursor . sb_h_double_arrow)
     (top-edge . 0)
     (right-edge . ,frame-edge)
     (width . ,frame-width)
     (bottom-edge . 0))))

(define title-group
  `(((class . top-border)
     (background . ,top-border-images)
     (cursor . sb_v_double_arrow)
     (left-edge . 0)
     (top-edge . -18)
     (right-edge . 0)
     (height . 2))
    ((class . tab)
     (background . ,tab-images)
     (foreground . ,title-colors-images)
     (y-justify . center)
     (x-justify . center)
     (top-edge . -16)
     (height . 16)
     (text . ,window-name))
    ((class . tab-l)
     (foreground . ,(lambda (w) (window-icon w)))
     (background . ,tab-left-icon-images)
;     (cursor . hand2)
     (top-edge . -16)
     (height . 16)
     (width . 16)
     (y-justify . 2)
     (x-justify . 5))
    ((class . tab-r)
     (background . ,tab-right-images)
     (top-edge . -16))))


(define close-button
  `((class . close-button)
    (background . ,close-button-images)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define menu-button
  `((class . menu-button)
    (background . ,menu-button-images)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define iconify-button
  `((class . iconify-button)
    (background . ,iconify-button-images)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define maximize-button
  `((class . maximize-button)
    (background . ,maximize-image-set)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define shade-button
  `((class . shade-button)
    (background . ,shade-image-set)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define sticky-button
  `((class . sticky-button)
    (background . ,sticky-image-set)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define space-button
  `((class . title)
    (background . ,title-images)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define prev-button
  `((class . prev-button)
    (background . ,prev-image-set)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define next-button
  `((class . next-button)
    (background . ,next-image-set)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define lock-button
  `((class . lock-button)
    (background . ,lock-image-set)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define raise-lower-button
  `((class . raise-lower-button)
    (background . ,raise-lower-image-set)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define  move-resize-button
  `((class . move-resize-button)
    (background . ,move-resize-button-images)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define rename-button
  `((class . rename-button)
    (background . ,rename-button-images)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define frame-typ-button
  `((class . frame-typ-button)
    (background . ,frame-typ-button-images)
;    (cursor . hand2)
    (top-edge . -16)
    (height . 16)
    (width . 16)))

(define shaped-border-corner-group
  `(((class . top-left-corner)
     (background . ,top-left-corner-shaped-images)
     (cursor . sb_h_double_arrow)
     (left-edge . ,frame-edge)
     (top-edge . -18)
     (height . 18)
     (width . ,frame-width))
	((class . top-right-corner)
     (background . ,top-right-corner-shaped-images)
     (cursor . sb_h_double_arrow)
     (top-edge . -18)
     (right-edge . ,frame-edge)
     (height . 18)
     (width . ,frame-width))
    ((class . title)
     (background . ,title-images)
     (right-edge . 0)
     (top-edge . -16)
     (height . 16)
     (width . 2))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define normal-frame nil)
(define shaped-frame nil)
(define transient-frame nil)
(define shaped-transient-frame nil)

(define create-frames
  ;; ripped from Anonymous
  ;;
  (lambda ()
    (let* ( ; mapping from button names to definitions
           (button-alist
            `((close  . ,close-button)
              (menu   . ,menu-button)
              (minimize   . ,iconify-button)
              (maximize   . ,maximize-button)
              (shade  . ,shade-button)
              (sticky . ,sticky-button)
              (space . ,space-button)
              (send-to-prev . ,prev-button)
              (send-to-next . ,next-button)
              (lock . ,lock-button)
              (raise-lower . ,raise-lower-button)
              (move-resize . ,move-resize-button)
              (rename . ,rename-button)
              (frame-typ . ,frame-typ-button)
              (\(none\)   . ,nil)))

           ;; turns one cons cell (btn-name . show-in-transients) into a button
           ;; definition, adding the button position
           ;;
           (make-button
            (lambda (is-trans btn edge pos)
              (let ((btn-def  (cdr (assq (car btn) button-alist)))
                    (btn-in-trans (last btn)))
                (if (or (null btn-def) (and is-trans (not btn-in-trans)))
                    nil
                  (cons (cons edge pos) btn-def)))))

           ;; turns the list of cons cells (btn-name . show-in-transients) into
           ;; a list of button definitions, adding the button positions
           ;;
           (make-button-list
            (lambda (is-trans btn-list edge pos-start pos-inc)
              (let loop ((rest btn-list) (pos pos-start) (result ()))
                   (if (null rest)
                       result
                     (let ((new-btn (make-button is-trans (car rest) edge pos)))
                       (if (null new-btn)
                           (loop (cdr rest) pos result)
                         (loop (cdr rest) (+ pos pos-inc) (append (list new-btn) result))))))))

           (normal-buttons-left
            (make-button-list nil dark-tab:left-buttons 'left-edge  0 16))
           (normal-buttons-right
            (make-button-list nil dark-tab:right-buttons 'right-edge 0 16))
           
           (transient-buttons-left
            (make-button-list t dark-tab:left-buttons 'left-edge  0 16))
           (transient-buttons-right
            (make-button-list t dark-tab:right-buttons 'right-edge 0 16)))

      (setq normal-frame
            (append title-group normal-buttons-left default-border-corner-group border-group normal-buttons-right))
      (setq shaped-frame
            (append title-group normal-buttons-left shaped-border-corner-group normal-buttons-right))
      (setq transient-frame
            (append title-group transient-buttons-left default-border-corner-group border-group transient-buttons-right))
      (setq shaped-transient-frame
            (append title-group transient-buttons-left shaped-border-corner-group transient-buttons-right)))))

(create-frames)

;; At last! We create the actual theme
;;
(add-frame-style theme-name
                 (lambda (w type)
                   (case type
                         ((default)				normal-frame)
                         ((shaped)				shaped-frame)
                         ((transient)			transient-frame)
                         ((shaped-transient)	shaped-transient-frame)
                         ((utility)			    normal-frame)
                         ((shaded-utility)	    normal-frame)
                         ((unframed)			nil-frame))))

;; Set conditions for calling the frame update functions
;;
(define (reframe-one w)
  (if (eq (window-get w 'current-frame-style) theme-name)
      (rebuild-frame w)))

(define reframe-all
  (lambda ()
    (create-frames)
    (reframe-windows-with-style theme-name))) 

(call-after-property-changed '(WM_NAME _NET_WM_NAME _NET_WM_STATE _NET_WM_DESKTOP) reframe-one)
(call-after-property-changed 'WM_HINTS  reframe-one)
(call-after-state-changed '(sticky fixed-position) reframe-one)

(custom-set-property 'dark-tab:focused-color ':after-set reframe-all)
(custom-set-property 'dark-tab:highlighted-color ':after-set reframe-all)
(custom-set-property 'dark-tab:clicked-color ':after-set reframe-all)
(custom-set-property 'dark-tab:inactive-color ':after-set reframe-all)
(custom-set-property 'dark-tab:inactive-highlighted-color ':after-set reframe-all)
(custom-set-property 'dark-tab:inactive-clicked ':after-set reframe-all)
(custom-set-property 'dark-tab:show-window-icons ':after-set reframe-all)
(custom-set-property 'dark-tab:borders-dimension ':after-set reframe-all)
(custom-set-property 'dark-tab:left-buttons ':after-set reframe-all)
(custom-set-property 'dark-tab:right-buttons ':after-set reframe-all)

;; when the window is sent to another workspace
;; redraw it to update the buttons and titlebar if necessary
;;
(add-hook 'remove-from-workspace-hook
          (lambda (w)
            (reframe-window w)))
